import { ElMessage } from 'element-plus';

const isNotValid = (val) => {
    const timeRegex = /^([0-1]?[0-9]|2[0-3]):([0-5]?[0-9])-(?:[0-1]?[0-9]|2[0-3]):([0-5]?[0-9])$/;
    const rangeRegex = /^\(\d+,\d+\)$/
    return timeRegex.test(val.timeSlot) && rangeRegex.test(val.numberRange)
}

const isValidPlus = (val) => {
    const timeRegex = /^([0-1]?[0-9]|2[0-3]):([0-5]?[0-9])-(?:[0-1]?[0-9]|2[0-3]):([0-5]?[0-9])$/;
    const rangeRegex = /^\(\d+,\d+\)$/
    if(val.timeSlot === '' &&  val.numberRange === '') return false
    if(timeRegex.test(val.timeSlot) && rangeRegex.test(val.numberRange)) return false
    return true
}

export const transfer = (val, arr, isAvailableArr) => {
    for (var i = 0; i < val.length; i ++ ) {
        for (var j = 0; j < val[i].length; j ++ ) {
            arr[i][j].timeSlot = val[i][j].startTime + "-" + val[i][j].endTime
            arr[i][j].numberRange = "(" + val[i][j].minNumValue + "," + val[i][j].maxNumValue + ")"
        }
    }
    // console.log(arr)
    for (var i = 0; i < 4; i ++ ) {
        for (var j = 0; j < 6; j ++ ) {
            if(isValidPlus(arr[i][j])) {
                ElMessage({
                     type: 'error',
                     message: '请检查表单数据是否完整填写'
                })
                return ;
            }
        }
    }
    let newArr = new Array(4)
    for (var i = 0; i < 4; i ++ ) {
        newArr[i] = {
            timeSlot:'',
            numberRange: '',
            isAvailable: false
        }
    }

    let timeSlotArr = []
    let numberRangeArr = []
    for (var i = 0; i < val.length; i ++ ) {
        for (var j = 0; j < val[i].length; j ++ ) {
            if(isNotValid(arr[i][j])) {
                timeSlotArr.push(arr[i][j].timeSlot)
                numberRangeArr.push(arr[i][j].numberRange)
            }
        }
        newArr[i].timeSlot = timeSlotArr.join(';')
        newArr[i].numberRange = numberRangeArr.join(';')
        newArr[i].isAvailable = isAvailableArr[i] ? 1 : 0
        timeSlotArr = []
        numberRangeArr = []
    }
    ElMessage({
        type: 'success',
        message: '时间段保存成功'
   })
    // console.log(newArr)
    return newArr
}